; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
GL_MULTISAMPLE_ARB	equ 809Dh
WGL_SAMPLE_BUFFERS_ARB	equ 2041h
WGL_SAMPLES_ARB		equ 2042h
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:cmp	doangle,0
	jz	@f
	movss	xmm0,angle
	addss	xmm0,const0_05
	movss	angle,xmm0
@@:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_M
	jne	@f
	xor	doangle,1
@@:	cmp	al,VK_SPACE
	jne	wmBYE
	xor	domulti,1
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	mov	r8d,milliseconds
	invoke	SetTimer,hWin,10,,0;  #10  25mSec
;-------------------------------------------------------
	mov	r8d,offset PixFrm
	invoke	InitMultisample,IMAGE_BASE,hWin
	invoke	glViewport,0,0,WINDOWWIDTH,WINDOWHEIGHT;	// Set Up A Viewport
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity; Reset The Projection Matrix
	movsd	xmm3,constd2000
	movsd	xmm2,constd5
	mov	eax,WINDOWWIDTH
	cvtsi2sd xmm1,eax
	mov	eax,WINDOWHEIGHT
	cvtsi2sd xmm0,eax
	divsd	xmm1,xmm0
	movsd	xmm0,constd50
	invoke	gluPerspective;(50, (float)window->init.width/(float)window->init.height, 5,  2000); // Set Our Perspective
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing

	invoke	glShadeModel,GL_SMOOTH; Select Smooth Shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;0, 0, 0, 0.5; Set The Clear Color To Black
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd2000
	movq	xmm2,constd5
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd50
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  ROACH
	cmp	domulti,0;if(domulti)
	jz	@f
	invoke	glEnable,GL_MULTISAMPLE_ARB; Enable Our Multisampling
; ENDROACH
@@:     movss	xmm3, const0_5
	xorps	xmm2, xmm2
	xorps	xmm1, xmm1
	xorps	xmm0, xmm0
	invoke	glClearColor;0, 0, 0, 0.5 Set The Clear Color To Black
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke	glLoadIdentity; Reset The View	
	mov	edi,-10;	for(float i=-10;i<10;i++)
@@:	mov	esi,-10;	for(float j=-10;j<10;j++)
@1:     invoke	glPushMatrix
	movss	xmm2,const_5
	cvtsi2ss xmm1,esi
	addss	xmm1,xmm1
	cvtsi2ss xmm0,edi
	addss	xmm0,xmm0
	invoke	glTranslatef;i*2,j*2,-5
        movss	xmm3, const1
	xorps	xmm2, xmm2
	xorps	xmm1, xmm1
	movss	xmm0,angle
	invoke	glRotatef;angle,0,0,1
	invoke	glBegin,GL_QUADS
	xorps	xmm2, xmm2
	xorps	xmm1, xmm1
	movss	xmm0,const1
	invoke	glColor3f;1,0,0
	xorps	xmm2, xmm2
	cvtsi2ss xmm1,esi
	cvtsi2ss xmm0,edi
	invoke	glVertex3f;i,j,0
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glColor3f;0,1,0
	xorps	xmm2,xmm2
	cvtsi2ss xmm1,esi
	cvtsi2ss xmm0,edi
	addss	xmm0,const2
	invoke	glVertex3f;i + 2,j,0
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glColor3f;0,0,1
	xorps	xmm2,xmm2
	cvtsi2ss xmm1,esi
	addss	xmm1,const2
	cvtsi2ss xmm0,edi
	addss	xmm0,const2
	invoke	glVertex3f;i + 2,j + 2,0
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;1,1,1
	xorps	xmm2,xmm2
	cvtsi2ss xmm1,esi
	addss	xmm1,const2
	cvtsi2ss xmm0,edi
	invoke	glVertex3f;i,j + 2,0
	invoke	glEnd
	invoke	glPopMatrix
	inc	esi
	cmp	esi,10
	jl	@1
	inc	edi
	cmp	edi,10
	jl	@b
	invoke	glFlush; Flush The GL Rendering Pipeline
; ROACH
	cmp	domulti,0
	jz	@f
	invoke	glDisable,GL_MULTISAMPLE_ARB
; ENDROACH
@@:	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
; WGLisExtensionSupported: This Is A Form Of The Extension For WGL
WGLisExtensionSupported proc extension:dword
local	extlen:dword
local	supported:dword
local	wglGetExtString:qword
local	p:qword

	mov	extension,ecx

	invoke	strlen
	mov	extlen,eax;const size_t extlen = strlen(extension)
	and	supported, 0;const char *supported = NULL
; Try to use wglGetExtensionStringARB on current DC, if possible
	mov	ecx,offset aWglgetextensio ; "wglGetExtensionsStringARB"
	invoke	wglGetProcAddress
	mov	wglGetExtString,rax;PROC wglGetExtString = wglGetProcAddress("wglGetExtensionsStringARB")
	or	eax,eax;if (wglGetExtString0)
	jz	@f
	invoke	wglGetCurrentDC
	invoke	wglGetExtString,eax
	mov	supported,eax;supported = ((char*(__stdcall*)(HDC))wglGetExtString)(wglGetCurrentDC())
; If that failed, try standard Opengl Extensions String
@@:	cmp	supported,0;if (supported == NULL)
	jnz	@f
	invoke	glGetString, GL_EXTENSIONS
	mov	supported,eax
	or	eax,eax
	jz	exit0
; ---------------------------------------------------------------------------
@@:	mov	eax, supported
	mov	p, rax
; Begin examination at start of string, increment by 1 on false match
; Advance p up to the next possible match
@0:	mov	edx, extension ; SubStr
	invoke	strstr, p;invoke strstr,p,extension
	mov	p, rax
	or	eax,eax
	jz	exit0;if (p == NULL) return false
; ---------------------------------------------------------------------------
@@:	cmp	eax, supported
	jz	@f;if(p==supported)
	or	rcx,-1
	cmp	byte ptr [rcx+rax],' '
	jnz	@1;if(p[-1]==' ')
@@:	mov	ecx, extlen
	cmp	byte ptr [rcx+rax],0;if(p[extlen]==0)
	jz	@f
	cmp	byte ptr [rcx+rax],' ';if(p[extlen]==' ')
	jz	@f;if ((p==supported || p[-1]==' ')&& (p[extlen]=='\0' || p[extlen]==' ')) return true
@1:	inc	p
	jmp	@0
@@:	mov	al, TRUE
exit0:	leave
	ret
WGLisExtensionSupported endp
; InitMultisample: Used To Query The Multisample Frequencies
InitMultisample proc hInstance:qword,hWnd:qword,pfd:qword
local	wglChoosePixelFormatARB:qword
local	hDC:qword
local	pixelFormat:dword
local	valid:dword
local	numFormats:dword
local	fAttributes[2]:dword
local	iAttributes[22]:dword	

	mov	hWnd,rdx
	mov	pfd,r8
; See If The String Exists In WGL!
	mov	ecx,offset aWgl_arb_multis
	invoke	WGLisExtensionSupported
	cmp	al,0
	jnz	@f;if (!WGLisExtensionSupported("WGL_ARB_multisample"))
	and	arbMultisampleSupported,FALSE;arbMultisampleSupported=false;
	jmp	exit0;return false;
; Get Our Pixel Format
@@:	mov	ecx,offset aWglchoosepixel
	invoke	wglGetProcAddress;PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)wglGetProcAddress("wglChoosePixelFormatARB")
	mov	wglChoosePixelFormatARB,rax
	or	eax,eax
	jnz	@f;if (!wglChoosePixelFormatARB) 
	mov	arbMultisampleSupported,FALSE;arbMultisampleSupported=false;
	jmp	exit0;return false;
; Get Our Current Device Context
@@:	mov	rcx,hWnd
	invoke	GetDC;HDC hDC = GetDC(hWnd);
	mov	hDC,rax
	xor	eax,eax
	mov	fAttributes[0*4],eax;	float	fAttributes[] = {0,0};
	mov	fAttributes[1*4],eax
; These Attributes Are The Bits We Want To Test For In Our Sample
; Everything Is Pretty Standard, The Only One We Want To 
; Really Focus On Is The SAMPLE BUFFERS ARB And WGL SAMPLES
; These Two Are Going To Do The Main Testing For Whether Or Not
; We Support Multisampling On This Hardware.
	mov	iAttributes[0*4],WGL_DRAW_TO_WINDOW_ARB
	mov	iAttributes[1*4],GL_TRUE
	mov	iAttributes[2*4],WGL_SUPPORT_OPENGL_ARB
	mov	iAttributes[3*4],GL_TRUE
	mov	iAttributes[4*4],WGL_ACCELERATION_ARB
	mov	iAttributes[5*4],WGL_FULL_ACCELERATION_ARB
	mov	iAttributes[6*4],WGL_COLOR_BITS_ARB
	mov	iAttributes[7*4],24
	mov	iAttributes[8*4],WGL_ALPHA_BITS_ARB
	mov	iAttributes[9*4],8
	mov	iAttributes[10*4],WGL_DEPTH_BITS_ARB
	mov	iAttributes[11*4],16
	mov	iAttributes[12*4],WGL_STENCIL_BITS_ARB
	mov	iAttributes[13*4],eax
	mov	iAttributes[14*4],WGL_DOUBLE_BUFFER_ARB
	mov	iAttributes[15*4],GL_TRUE
	mov	iAttributes[16*4],WGL_SAMPLE_BUFFERS_ARB
	mov	iAttributes[17*4],GL_TRUE
	mov	iAttributes[18*4],WGL_SAMPLES_ARB
	mov	iAttributes[19*4],4
	mov	iAttributes[20*4],eax
	mov	iAttributes[21*4],eax
; int iAttributes[] = {WGL_DRAW_TO_WINDOW_ARB,GL_TRUE,WGL_SUPPORT_OPENGL_ARB,
; GL_TRUE,WGL_ACCELERATION_ARB,WGL_FULL_ACCELERATION_ARB,WGL_COLOR_BITS_ARB,24,
; WGL_ALPHA_BITS_ARB,8,WGL_DEPTH_BITS_ARB,16,WGL_STENCIL_BITS_ARB,0,WGL_DOUBLE_BUFFER_ARB,
; GL_TRUE,WGL_SAMPLE_BUFFERS_ARB,GL_TRUE,WGL_SAMPLES_ARB,4,0,0}

; First we check to see if we can get a pixel format for 4 samples
	lea	eax,numFormats
	mov	[rsp+28h],rax
	lea	eax,pixelFormat
	mov	[rsp+20h],rax
        lea	r8d,fAttributes
	lea	edx,iAttributes
	invoke	wglChoosePixelFormatARB,hDC,,,1
	mov	valid,eax;valid = wglChoosePixelFormatARB(hDC,iAttributes,fAttributes,1,&pixelFormat,&numFormats)
; If we returned true, and our format count is greater than 1
	or	eax,eax
	jz 	@f
	cmp	numFormats,1
	jb	@f;if (valid && numFormats >= 1)
	mov	arbMultisampleSupported,TRUE;arbMultisampleSupported = true
	mov	eax,pixelFormat
	mov	arbMultisampleFormat,eax;arbMultisampleFormat = pixelFormat
	jmp	@0;return arbMultisampleSupported
; Our pixel format with 4 samples failed, test for 2 samples
@@:	mov	iAttributes[19*4],2;iAttributes[19] = 2
	lea	eax,numFormats
	mov	[rsp+28h],rax
	lea	eax,pixelFormat
	mov	[rsp+20h],rax
        lea	r8d,fAttributes
	lea	edx,iAttributes
	invoke	wglChoosePixelFormatARB,hDC,,,1
	mov	valid,eax;valid = wglChoosePixelFormatARB(hDC,iAttributes,fAttributes,1,&pixelFormat,&numFormats)
	or	eax,eax
	jz	@0
	cmp	numFormats,1
	jb	@0;if (valid && numFormats >= 1)
	mov	arbMultisampleSupported,TRUE;arbMultisampleSupported = true
	mov	eax,pixelFormat
	mov	arbMultisampleFormat,eax;arbMultisampleFormat = pixelFormat
@0:	movzx	eax,arbMultisampleSupported;return arbMultisampleSupported;
exit0:	leave
	ret
InitMultisample endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;color bits Ignored
  	cAlphaBits        db	1;alpha buffer
  	cAlphaShift       db	0;Shift bit Ignored
  	cAccumBits        db	0;No accumulation buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;accumulation bits Ignored
  	cDepthBits        db	16;16bit Z-buffer (depth buffer)
  	cStencilBits      db	0;No Stencil buffer
  	cAuxBuffers       db	0;No auxiliary buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored
szClassName	db "NeHe lesson #46 - FSAA Tutorial",0
FileName	db "br_Rabbit3.cur",0
milliseconds	dd 3
angle	dd 0
domulti db TRUE;
doangle db TRUE
arbMultisampleSupported	db FALSE
arbMultisampleFormat dd 0
aWglgetextensio	db 'wglGetExtensionsStringARB',0
aWglchoosepixel	db 'wglChoosePixelFormatARB',0
aWgl_arb_multis	db 'WGL_ARB_multisample',0
;-----------------------------
;float
const0_001	dd 0.001
const0_05	dd 0.05
const0_5	dd 0.5
const1		dd 1.0
const_1		dd -1.0
const2		dd 2.0
const_5		dd -5.0
const10		dd 10.0
const17		dd 17.0
const_18	dd -18.0
const45		dd 45.0
const1000	dd 1000.0
const_1000	dd -1000.0
const5000	dd 5000.0
const10000	dd 10000.0
;double
constd0_1	dq 0.1
constd1		dq 1.0
constd5		dq 5.0
constd50	dq 50.0
constd2000	dq 2000.0
end